import torch
import torch.nn as nn
import torch.nn.functional as F

class NormFaceLoss(nn.Module):
    def __init__(self, temp=10, weight=None):
        super(NormFaceLoss, self).__init__()
        self.temp = temp
        self.weight = weight

    def forward(self, logits, labels):
        logits = logits * self.temp
        max_logits = torch.max(logits, dim=1, keepdim=True)[0]
        return F.cross_entropy(logits - max_logits, labels, weight=self.weight)